using System;
using System.Collections.Generic;
using JetBrains.Annotations;
using Newtonsoft.Json;

namespace Magify.Model
{
    internal class CampaignsContext
    {
        [JsonProperty("limits")]
        [CanBeNull]
        public Limits Limits { get; set; }

        [JsonProperty("campaigns")]
        [CanBeNull]
        public List<CampaignModel> CampaignModels { get; set; }

        [JsonProperty("product_ids")]
        [CanBeNull]
        public List<DefaultProduct> DefaultProducts { get; set; }

        [JsonProperty("content")]
        [CanBeNull]
        public Dictionary<string, ContentGroup> Content { get; set; }

        [JsonProperty("default_content")]
        [CanBeNull]
        public List<DefaultContentItem> DefaultContent { get; set; }

        [JsonProperty("app_features")]
        [CanBeNull]
        public Dictionary<string, FeatureConfig> Features { get; set; }

        [JsonProperty("tracked_app_ids")]
        [CanBeNull]
        public HashSet<string> TrackedAppIds { get; set; }

        [JsonProperty("context_built_at")]
        [JsonConverter(typeof(UnitDateTimeConverter), TimeUnit.Second, true)]
        [CanBeNull]
        public DateTime? ContextBuildTime { get; set; }

        public static CampaignsContext Deserialize(string json)
        {
            // TODO handle all possible deserialization errors here
            // TODO for example - unexpected enum values
            if (string.IsNullOrEmpty(json))
            {
                return null;
            }

            var context = JsonFacade.DeserializeObject<CampaignsContext>(json);
            return context;
        }
    }
}