using System.Collections.Generic;
using System.Threading;
using Magify.Model;
using Cysharp.Threading.Tasks;

namespace Magify
{
    internal interface IServerApi
    {
        void ChangeServerUrl(EndpointUrl url);
        UniTask<CampaignsContext> GetContextAsync(CancellationToken cancellationToken = default);

        UniTask<bool> SendEvents<T>(EventType eventType, IList<T> events, CancellationToken cancellationToken = default)
            where T : class, IAnalyticsEvent;

        UniTask<PurchaseVerificationResult> VerifyPurchase(PurchaseRecord purchaseRecord, bool waitForResult, CancellationToken cancellationToken);
    }
}