using System;

namespace Magify
{
    internal class ExponentialBackoff
    {
        private readonly ulong _delayMilliseconds;
        private readonly ulong _maxDelayMilliseconds;

        public uint Retries { get; private set; }

        public uint Pow { get; private set; }

        public ExponentialBackoff(ulong delayMilliseconds = 1000, ulong maxDelayMilliseconds = 64000)
        {
            _delayMilliseconds = delayMilliseconds;
            _maxDelayMilliseconds = maxDelayMilliseconds;
            Reset();
        }

        public void Reset()
        {
            Retries = 0;
            Pow = 1;
        }

        public ulong NextDelay()
        {
            ++Retries;
            if (Retries < 31)
            {
                Pow = Pow << 1;
            }
            return Math.Min(_delayMilliseconds * (Pow - 1) / 2, _maxDelayMilliseconds);
        }
    }
}