﻿using System.IO;
using UnityEngine;

namespace Magify.Tests
{
    public static class EditorModeTestsEnvironment
    {
        public static readonly string RootStoragePath = Path.Combine(Application.temporaryCachePath, PackageInfo.FolderName);
        public static readonly string TempStoragePath = Path.Combine(RootStoragePath, "test.bin");
        public static readonly string GeneralPrefsPath = Path.Combine(RootStoragePath, IMagifyClient.GeneralPrefsName);
        public static readonly string OffersPrefsName = Path.Combine(RootStoragePath, IMagifyClient.OffersPrefsName);
        public static readonly string CountersFolderPath = Path.Combine(RootStoragePath, IMagifyClient.CountersFolderName);

        public static void Clear()
        {
            if (Directory.Exists(RootStoragePath))
            {
                Directory.Delete(RootStoragePath, true);
            }
        }
    }
}